from tkinter import *
import random, time
#--------------(共通関数)-------------
def array(N1, N2=0,N3=0,init=0):   #■配列宣言
    if N2==0: return [init for i in range(N1)]
    if N3==0: return [[init for i in range(N2)]
                      for j in range(N1)]
    return[[[init for i in range(N3)]for j in range(N2)]
           for k in range(N1)]
def initData(canvas, numX,numY):
    ID=array(numX,numY); DD=400/numX
    for x in range(numX):
        X=x*DD+20
        for y in range(numY):
            Y=y*DD+20; CL="white"
            if random.random()<0.5:CL="green"
            ID[x][y]=canvas.create_rectangle(X,Y,X+DD,Y+DD,fill=CL)
    return ID
def getDT(canvas,ID):#■データ取り出し
    numX=len(ID);numY=len(ID[0])        # 添字判定を少なくするため
    DTab=array(numX,numY,init=False)# 周りにFalseを詰め
    for x in range(numX):               # 配列位置を1だけずらす
        for y in range(numY):
            CL=canvas.itemcget(ID[x][y], option="fill");k=0
            DTab[x][y]=(CL=="green")
    return DTab
def cID(k,num):
    if k<0: return num-1
    if k>=num:return 0
    return k
def execLG(canvas,ID,numX,numY):#■ライフ・ゲームの実行
    DTab=getDT(canvas,ID)
    for jj in range(numX):
        for ii in range(numY):
            Count=0
            for k1 in range(-1,2):# 周りの生物カウント
                for k2 in range(-1,2):
                    if k1!=0 or k2!=0:# 該当セル以外のみカウント
                        i2=cID(ii+k1,numY); j2=cID(jj+k2,numX)
                        if DTab[i2][j2]: Count += 1
            if DTab[ii][jj]:
                if Count!=2 and Count!= 3:#個数2,3でないとき死ぬ
                    canvas.itemconfig(ID[ii][jj], fill="white")
            elif Count==3:#個数3のとき産まれる
                    canvas.itemconfig(ID[ii][jj], fill="green")
def Lbutton(event):
    global exeFlag,root,canvas,ID,numX,numY
    exeFlag=False
    root.update();time.sleep(0.1)
    execLG(canvas,ID,numX,numY)
def Rbutton(event):
    global root,canvas,ID,numX,numY
    DX=400/numX;DY=400/numY
    x=int((event.x-20)/DX)
    y=int((event.y-20)/DY)
    CL=canvas.itemcget(ID[x][y], option="fill")
    if CL=="green":CL="white"
    else: CL="green"
    canvas.itemconfig(ID[x][y], fill=CL)
def Hbutton(event):
    global root,canvas,ID,numX,numY
    for x in range(numX):
        for y in range(numY):
            canvas.itemconfig(ID[x][y], fill="white")
root=Tk();root.title("Cyclic Life Game")
canvas=Canvas(root,width=440,height=440,bg="white")
canvas.pack();root.update()
exeFlag=True; canvas.bind("<1>",Lbutton)
canvas.bind("<3>",Rbutton)
canvas.bind("<2>",Hbutton)
numX=40;numY=40; ID=initData(canvas,numX,numY)
while exeFlag:
    root.update();time.sleep(0.1)
    execLG(canvas,ID,numX,numY)
mainloop()
    



